1 # Customize maint.mk -*- makefile -*-
2 # Copyright (C) 2003-2015 Free Software Foundation, Inc.
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 3 of the License, or
7 # (at your option) any later version.
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see <http://www.gnu.org/licenses/>.
17 # Used in maint.mk's web-manual rule
18 manual_title
= Core GNU utilities
20 # Use the direct link. This is guaranteed to work immediately, while
21 # it can take a while for the faster mirror links to become usable.
22 url_dir_list
= http
://ftp.gnu.org
/gnu
/$(PACKAGE
)
24 # Tests not to run as part of "make distcheck".
25 local-checks-to-skip
= \
26 sc_proper_name_utf8_requires_ICONV
28 # Tools used to bootstrap this package, used for "announcement".
29 bootstrap-tools
= autoconf
,automake
,gnulib
,bison
31 # Now that we have better tests, make this the default.
34 # Comparing tarball sizes compressed using different xz presets, we see that
35 # an -8e-compressed tarball is only 9KiB larger than the -9e-compressed one.
36 # Using -8e is preferred, since that lets the decompression process use half
37 # the memory (32MiB rather than 64MiB).
38 # $ for i in {7,8,9}{e,}; do \
39 # (n=$(xz -$i < coreutils-8.15*.tar|wc -c);echo $n $i) & done |sort -nr
48 old_NEWS_hash
= 41e5c3133f5d8947e2ff13aab58fc52b
50 # Add an exemption for sc_makefile_at_at_check.
51 _makefile_at_at_check_exceptions
= ' && !/^cu_install_prog/ && !/dynamic-dep/'
53 # Our help-version script is in a slightly different location.
54 _hv_file ?
= $(srcdir)/tests
/misc
/help-version
56 # Ensure that the list of O_ symbols used to compute O_FULLBLOCK is complete.
57 dd
= $(srcdir)/src
/dd.c
60 @
{ echo O_FULLBLOCK
; echo O_NOCACHE
; \
61 perl
-nle
'/^ +\| (O_\w*)$$/ and print $$1' $(dd
); } |
sort > $@
.1
62 @
{ echo O_NOFOLLOW
; perl
-nle
'/{"[a-z]+",\s*(O_\w+)},/ and print $$1' \
63 $(dd
); } |
sort > $@
.2
64 @diff
-u
$@
.1 $@
.2; diff
=$$?
; \
67 ||
{ echo
'$(ME): $(dd) has inconsistent O_ flag lists'>&2; \
70 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
71 # with the strings from the two affected variables.
72 dd_c
= $(srcdir)/src
/dd.c
74 ifneq ($(wildcard $(dd_c
)),)
75 @len
=$$( (sed
-n
'/conversions\[\] =$$/,/^};/p' $(dd_c
);\
76 sed
-n
'/flags\[\] =$$/,/^};/p' $(dd_c
) ) \
77 |sed
-n
'/"/s/^[^"]*"\([^"]*\)".*/\1/p'| wc
-L
);\
78 max
=$$(sed
-n
'/^#define LONGEST_SYMBOL /s///p' $(dd_c
) \
79 |tr
-d
'"' | wc
-L
); \
80 if
test "$$len" = "$$max"; then
:; else \
81 echo
'dd.c: LONGEST_SYMBOL is not longest' 1>&2; \
86 # Many m4 macros names once began with 'jm_'.
87 # On 2004-04-13, they were all changed to start with gl_ instead.
88 # Make sure that none are inadvertently reintroduced.
90 @grep
-nE
'jm_[A-Z]' \
91 $$($(VC_LIST
) m4 |grep
'\.m4$$'; echo
/dev
/null
) && \
92 { echo
'$(ME): do not use jm_ in m4 macro names' \
95 # Ensure that each root-requiring test is run via the "check-root" rule.
97 @t1
=sc-root.expected
; t2
=sc-root.actual
; \
98 grep
-nl
'^ *require_root_$$' `$(VC_LIST) tests` | \
99 sed
's|.*/tests/|tests/|' |
sort > $$t1; \
100 for t in
$(all_root_tests
); do echo
$$t; done |
sort > $$t2; \
101 st
=0; diff
-u
$$t1 $$t2 || st
=1; \
105 # Ensure that all version-controlled test cases are listed in $(all_tests).
106 sc_tests_list_consistency
:
108 test_extensions_rx
=`echo $(TEST_EXTENSIONS) \
109 | sed -e "s/ /|/g" -e "s/$$bs./$$bs$$bs./g"`; \
111 for t in
$(all_tests
); do echo
$$t; done
; \
113 $(SHELL
) build-aux
/vc-list-files tests \
114 | grep
-Ev
'^tests/(factor/(run|create-test)|init)\.sh$$' \
115 |
$(EGREP
) "$$test_extensions_rx\$$"; \
116 } |
sort | uniq
-u | grep .
&& exit
1; :
118 # Ensure that all version-controlled test scripts are executable.
120 @set
-o noglob
2>/dev
/null || set
-f
; \
121 find_ext
="-name '' "`printf -- "-o -name *%s " $(TEST_EXTENSIONS)`;\
122 find
$(srcdir)/tests
/ \
( $$find_ext \
) \
! -perm
-u
+x
-print \
123 | sed
-e
"s/^/$(ME): Please make test executable: /" | grep . \
126 # Ensure all gnulib patches apply cleanly
127 sc_ensure_gl_diffs_apply_cleanly
:
128 @find
$(srcdir)/gl
/ -name
'*.diff' | while read p
; do \
129 patch
--fuzz
=0 -f
-s
-d
$(srcdir)/gnulib
/ -p1
--dry-run
< "$$p" >&2 \
130 ||
{ echo
"$$p" >&2; echo
'To refresh all gl patches run:' \
131 'make refresh-gnulib-patches' >&2; exit
1; } \
134 # Avoid :>file which doesn't propagate errors
135 sc_prohibit_colon_redirection
:
136 @cd
$(srcdir)/tests
&& GIT_PAGER
= git grep
-n
': *>.*||' \
137 && { echo
'$(ME): '"The leading colon in :> will hide errors" 1>&2; \
141 # Create a list of regular expressions matching the names
142 # of files included from system.h. Exclude a couple.
144 @sed
-n
'/^# *include /s///p' $(srcdir)/src
/system.h \
145 | grep
-Ev
'sys/(param|file)\.h' \
146 | sed
's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
151 Exit
() { set
+e
; (exit
$$1); exit
$$1; }; \
152 for sig in
1 2 3 13 15; do \
153 eval
"trap 'Exit $$(expr $$sig + 128)' $$sig"; \
157 # Files in src/ should not include directly any of
158 # the headers already included via system.h.
159 sc_system_h_headers
: .re-list
160 @if
test -f
$(srcdir)/src
/system.h
; then \
161 trap
'rc=$$?; rm -f .re-list; exit $$rc' 0; \
163 grep
-nE
-f .re-list \
164 $$($(VC_LIST_EXCEPT
) | grep
'^\($(srcdir)/\)\?src/') \
165 && { echo
'$(ME): the above are already included via system.h'\
166 1>&2; exit
1; } ||
:; \
169 # Files in src/ should not use '%s' notation in format strings,
170 # i.e., single quotes around %s (or similar) should be avoided.
171 sc_prohibit_quotes_notation
:
172 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
"\".*[\`']%s'.*\"" *.c \
173 && { echo
'$(ME): '"Use quote() to avoid quoted '%s' notation" 1>&2; \
179 'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
180 $$($(VC_LIST_EXCEPT
)) && \
181 { echo
'$(ME): found misuse of Sun OS version numbers' 1>&2; \
184 # Ensure that the list of programs and author names is accurate.
185 # We need a UTF8 locale. If a lack of locale support or a missing
186 # translation inhibits printing of UTF-8 names, just skip this test.
187 au_dotdot
= authors-dotdot
188 au_actual
= authors-actual
189 sc_check-AUTHORS
: $(all_programs
)
190 @locale
=en_US.UTF-8
; \
191 LC_ALL
=$$locale .
/src
/cat
--version \
192 | grep
' Torbjorn ' > /dev
/null \
193 && { echo
"$@: skipping this check"; exit
0; }; \
194 rm -f
$(au_actual
) $(au_dotdot
); \
195 for i in
`ls $(all_programs) \
196 | sed -e 's,^src/,,' -e 's,$(EXEEXT)$$,,' \
198 | $(ASSORT) -u`; do \
199 test "$$i" = '[' && continue
; \
201 if
test "$$i" = install; then \
203 elif
test "$$i" = test; then \
206 LC_ALL
=$$locale .
/src
/$$exe --version \
207 | perl
-0 -p
-e
's/,\n/, /gm' \
208 | sed
-n
-e
'/Written by /{ s//'"$$i"': /;' \
209 -e
's/,* and /, /; s/\.$$//; p; }'; \
210 done
> $(au_actual
) && \
211 sed
-n
'/^[^ ][^ ]*:/p' $(srcdir)/AUTHORS
> $(au_dotdot
) \
212 && diff
$(au_actual
) $(au_dotdot
) \
213 && rm -f
$(au_actual
) $(au_dotdot
)
215 # Each program with a non-ASCII author name must link with LIBICONV.
216 sc_check-I18N-AUTHORS
:
217 @cd
$(srcdir)/src
&& \
218 for i in
$$(git grep
-l
-w proper_name_utf8
*.c|sed
's/\.c//'); do \
219 grep
-E
"^src_$${i}_LDADD"' .?= .*\$$\(LIBICONV\)' local.mk \
221 ||
{ echo
"$(ME): link rules for $$i do not include" \
222 '$$(LIBICONV)' 1>&2; exit
1; }; \
225 # Disallow the C99 printf size specifiers %z and %j as they're not portable.
226 # The gnulib printf replacement does support them, however the printf
227 # replacement is not currently explicitly depended on by the gnulib error()
228 # module for example. Also we use fprintf() in a few places to output simple
229 # formats but don't use the gnulib module as it is seen as overkill at present.
230 # We'd have to adjust the above gnulib items before disabling this.
231 sc_prohibit-c99-printf-format
:
232 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
'%[0*]*[jz][udx]' *.c \
233 && { echo
'$(ME): Use PRI*MAX instead of %j or %z' 1>&2; exit
1; } \
236 # Ensure the alternative __attribute (keyword) form isn't used as
237 # that form is not elided where required. Also ensure that we don't
238 # directly use attributes already defined by gnulib.
239 # TODO: move the check for _GL... attributes to gnulib.
240 sc_prohibit-gl-attributes
:
241 @prohibit
='__attribute |__(unused|pure|const)__' \
242 in_vc_files
='\.[ch]$$' \
243 halt
='Use _GL... attribute macros' \
246 # Look for lines longer than 80 characters, except omit:
247 # - program-generated long lines in diff headers,
248 # - the help2man script copied from upstream,
249 # - tests involving long checksum lines, and
250 # - the 'pr' test cases.
251 FILTER_LONG_LINES
= \
252 \|^
[^
:]*man
/help2man
:| d
; \
253 \|^
[^
:]*tests
/misc
/sha
[0-9]*sum.
*\.pl
[-:]| d
; \
254 \|^
[^
:]*tests
/pr
/|
{ \|^
[^
:]*tests
/pr
/pr-tests
:|
!d
; };
256 @wc
-L
/dev
/null
>/dev
/null
2>/dev
/null \
257 ||
{ echo
"$@: skipping: wc -L not supported"; exit
0; }; \
258 sed
-r
1q
/dev
/null
2>/dev
/null \
259 ||
{ echo
"$@: skipping: sed -r not supported"; exit
0; }; \
260 files
=$$($(VC_LIST_EXCEPT
) | xargs wc
-L | sed
-rn
'/ total$$/d;\
261 s/^ *(8[1-9]|9[0-9]|[0-9]\{3,\}) //p'); \
262 halt
='line(s) with more than 80 characters; reindent'; \
263 for file in
$$files; do \
264 expand
$$file | grep
-nE
'^.{80}.' | \
265 sed
-e
"s|^|$$file:|" -e
'$(FILTER_LONG_LINES)'; \
266 done | grep .
&& { msg
="$$halt" $(_sc_say_and_exit
) } ||
:
268 # Option descriptions should not start with a capital letter.
269 # One could grep source directly as follows:
270 # grep -E " {2,6}-.*[^.] [A-Z][a-z]" $$($(VC_LIST_EXCEPT) | grep '\.c$$')
271 # but that would miss descriptions not on the same line as the -option.
272 sc_option_desc_uppercase
: $(ALL_MANS
)
273 @grep
'^\\fB\\-' -A1 man
/*.1 | LC_ALL
=C grep
'\.1.[A-Z][a-z]' \
274 && { echo
1>&2 '$@: found initial capitals in --help'; exit
1; } ||
:
276 # Ensure all man/*.[1x] files are present.
277 sc_man_file_correlation
: check-x-vs-1 check-programs-vs-x
279 # Ensure that for each .x file in the 'man/' subdirectory, there is a
280 # corresponding .1 file in the definition of $(EXTRA_MANS).
281 # But since that expansion usually lacks programs like arch and hostname,
282 # add them here manually.
285 @PATH
=.
/src
$(PATH_SEPARATOR
)$$PATH; export PATH
; \
287 (cd
$(srcdir)/man
&& ls
-1 *.x
) \
288 | sed
's/\.x$$//' |
$(ASSORT
) > $$t; \
289 (echo
$(patsubst man
/%,%,$(ALL_MANS
)) \
290 | tr
-s
' ' '\n' | sed
's/\.1$$//') \
291 |
$(ASSORT
) -u | diff
- $$t ||
{ rm $$t; exit
1; }; \
294 # Writing a portable rule to generate a manpage like '[.1' would be
295 # a nightmare, so filter that out.
296 all-progs-but-lbracket
= $(filter-out [,$(patsubst src
/%,%,$(all_programs
)))
298 # Ensure that for each coreutils program there is a corresponding
299 # '.x' file in the 'man/' subdirectory.
300 .PHONY
: check-programs-vs-x
303 for p in dummy
$(all-progs-but-lbracket
); do \
304 case
$$p in
*.so
) continue
;; esac
; \
305 test $$p = dummy
&& continue
; \
306 test $$p = ginstall
&& p
=install ||
: ; \
307 test -f
$(srcdir)/man
/$$p.x \
308 ||
{ echo missing
$$p.x
1>&2; status
=1; }; \
312 # Ensure we can check out on case insensitive file systems
313 sc_case_insensitive_file_names
: src
/uniq
314 @git ls-files |
sort -f | src
/uniq
-Di | grep .
&& \
315 { echo
"$(ME): the above file(s) conflict on case insensitive" \
316 " file systems" 1>&2; exit
1; } ||
:
318 # Ensure that the end of each release's section is marked by two empty lines.
319 sc_NEWS_two_empty_lines
:
320 @sed
-n
4,/Noteworthy
/p
$(srcdir)/NEWS \
321 | perl
-n0e
'/(^|\n)\n\n\* Noteworthy/ or exit 1' \
322 ||
{ echo
'$(ME): use two empty lines to separate NEWS sections' \
325 # With split lines, don't leave an operator at end of line.
326 # Instead, put it on the following line, where it is more apparent.
327 # Don't bother checking for "*" at end of line, since it provokes
328 # far too many false positives, matching constructs like "TYPE *".
329 # Similarly, omit "=" (initializers).
330 binop_re_ ?
= [-/+^
!<>]|
[-/+*^
!<>=]=|
&&?|\|\|?|
<<=?|
>>=?
331 sc_prohibit_operator_at_end_of_line
:
332 @prohibit
='. ($(binop_re_))$$' \
333 in_vc_files
='\.[chly]$$' \
334 halt
='found operator at end of line' \
337 # Don't use "readlink" or "readlinkat" directly
338 sc_prohibit_readlink
:
339 @prohibit
='\<readlink(at)? \(' \
340 halt
='do not use readlink(at); use via xreadlink or areadlink*' \
343 # Don't use address of "stat" or "lstat" functions
344 sc_prohibit_stat_macro_address
:
345 @prohibit
='\<l?stat '':|&l?stat\>' \
346 halt
='stat() and lstat() may be function-like macros' \
349 # Ensure that date's --help output stays in sync with the info
350 # documentation for GNU strftime. The only exception is %N,
351 # which date accepts but GNU strftime does not.
352 extract_char
= sed
's/^[^%][^%]*%\(.\).*/\1/'
354 @if
test -f
$(srcdir)/src
/date.c
; then \
355 grep
'^ %. ' $(srcdir)/src
/date.c |
sort \
356 |
$(extract_char
) > $@
-src
; \
358 info libc date calendar format
2>/dev
/null \
359 | grep
"^ *['\`]%.'$$"|
$(extract_char
); }|
sort >$@
-info;\
360 if
test $$(stat
--format
%s
$@
-info) != 2; then \
361 diff
-u
$@
-src
$@
-info || exit
1; \
363 echo
'$(ME): skipping $@: libc info not installed' 1>&2; \
365 rm -f
$@
-src
$@
-info; \
368 # Indent only with spaces.
369 sc_prohibit_tab_based_indentation
:
371 halt
='TAB in indentation; use only spaces' \
374 # Enforce lowercase 'e' in "I.e.".
375 sc_prohibit_uppercase_id_est
:
377 halt
='Uppercase "Id Est" abbreviation; use "I.e.," instead' \
380 # Enforce double-space before "I.e." at the beginning of a sentence.
381 sc_ensure_dblspace_after_dot_before_id_est
:
382 @prohibit
='\. I\.e\.' \
383 halt
='Single space after dot before "i.e."; use ". i.e." instead' \
386 # Enforce comma after "i.e." (at least before a blank or at EOL).
387 sc_ensure_comma_after_id_est
:
388 @prohibit
='[Ii]\.e\.( |$$)' \
389 halt
='Missing comma after "i.e."; use "i.e.," instead' \
392 # The SEE ALSO section of a man page should not be terminated with
393 # a period. Check the first line after each "SEE ALSO" line in man/*.x:
394 sc_prohibit_man_see_also_period
:
395 @grep
-nB1
'\.$$' $$($(VC_LIST_EXCEPT
) | grep
'man/.*\.x$$') \
396 | grep
-A1
-e
'-\[SEE ALSO\]' | grep
'\.$$' && \
397 { echo
'$(ME): do not end "SEE ALSO" section with a period' \
400 # Don't use "indent-tabs-mode: nil" anymore. No longer needed.
401 sc_prohibit_emacs__indent_tabs_mode__setting
:
402 @prohibit
='^( *[*#] *)?indent-tabs-mode:' \
403 halt
='use of emacs indent-tabs-mode: setting' \
406 # Ensure that tests don't include a redundant fail=0.
408 @prohibit
='\<fail=0\>' \
409 halt
='fail=0 initialization' \
412 # Ensure that tests don't use `cmd ... && fail=1` as that hides crashes.
413 # The "exclude" expression allows common idioms like `test ... && fail=1`
414 # and the 2>... portion allows commands that redirect stderr and so probably
415 # independently check its contents and thus detect any crash messages.
416 sc_prohibit_and_fail_1
:
417 @prohibit
='&& fail=1' \
418 exclude
='(stat|kill|test |EGREP|grep|env|compare|2> *[^/])' \
419 halt
='&& fail=1 detected. Please use: returns_ 1 ... || fail=1' \
420 in_vc_files
='^tests/' \
423 # The mode part of a setfacl -m option argument must be three bytes long.
424 # I.e., an argument of user:bin:rw or user:bin:r will make Solaris 10's
425 # setfacl reject it with: "Unrecognized character found in mode field".
426 # Use hyphens to give it a length of 3: "...:rw-" or "...:r--".
427 sc_prohibit_short_facl_mode_spec
:
428 @prohibit
='\<setfacl .*-m.*:.*:[rwx-]{1,2} ' \
429 halt
='setfacl mode string length < 3; extend with hyphen(s)' \
432 # Ensure that "stdio--.h" is used where appropriate.
433 sc_require_stdio_safer
:
434 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
435 files
=$$(grep
-l
'\bfreopen \?(' $$($(VC_LIST_EXCEPT
) \
436 | grep
'\.[ch]$$')); \
437 test -n
"$$files" && grep
-LE
'include "stdio--.h"' $$files \
439 { echo
'$(ME): the above files should use "stdio--.h"' \
440 1>&2; exit
1; } ||
:; \
444 sc_prohibit_perl_hash_quotes
:
445 @prohibit
="\{'[A-Z_]+' *[=}]" \
446 halt
="in Perl code, write \$$hash{KEY}, not \$$hash{'K''EY'}" \
449 # Prefer xnanosleep over other less-precise sleep methods
451 @prohibit
='\<(nano|u)?sleep \(' \
452 halt
='prefer xnanosleep over other sleep interfaces' \
455 # Use print_ver_ (from init.cfg), not open-coded $VERBOSE check.
456 sc_prohibit_verbose_version
:
457 @prohibit
='test "\$$VERBOSE" = yes && .* --version' \
458 halt
='use the print_ver_ function instead...' \
461 # Use framework_failure_, not the old name without the trailing underscore.
462 sc_prohibit_framework_failure
:
463 @prohibit
='\<framework_''failure\>' \
464 halt
='use framework_failure_ instead' \
467 # Prohibit the use of `...` in tests/. Use $(...) instead.
468 sc_prohibit_test_backticks
:
469 @prohibit
='`' in_vc_files
='^tests/' \
470 halt
='use $$(...), not `...` in tests/' \
473 # Ensure that compare is used to check empty files
474 # so that the unexpected contents are displayed
475 sc_prohibit_test_empty
:
476 @prohibit
='test -s.*&&' in_vc_files
='^tests/' \
477 halt
='use `compare /dev/null ...`, not `test -s ...` in tests/' \
480 # Programs like sort, ls, expr use PROG_FAILURE in place of EXIT_FAILURE.
481 # Others, use the EXIT_CANCELED, EXIT_ENOENT, etc. macros defined in system.h.
482 # In those programs, ensure that EXIT_FAILURE is not used by mistake.
483 sc_some_programs_must_avoid_exit_failure
:
484 @grep
-nw EXIT_FAILURE \
485 $$(git grep
-El
'[^T]_FAILURE|EXIT_CANCELED' $(srcdir)/src
) \
486 | grep
-vE
'= EXIT_FAILURE|return .* \?' | grep . \
487 && { echo
'$(ME): do not use EXIT_FAILURE in the above' \
490 # Ensure that tests call the require_ulimit_v_ function if using ulimit -v
491 sc_prohibit_test_ulimit_without_require_
:
492 @
(git grep
-l require_ulimit_v_
$(srcdir)/tests
; \
493 git grep
-l
'ulimit -v' $(srcdir)/tests
) \
494 |
sort | uniq
-u | grep .
&& { echo
"$(ME): the above test(s)"\
495 " should match require_ulimit_v_ with ulimit -v" 1>&2; exit
1; } ||
:
497 # Ensure that tests call the cleanup_ function if using background processes
498 sc_prohibit_test_background_without_cleanup_
:
499 @
(git grep
-El
'( &$$|&[^&]*=\$$!)' $(srcdir)/tests
; \
500 git grep
-l
'cleanup_()' $(srcdir)/tests | sed p
) \
501 |
sort | uniq
-u | grep .
&& { echo
"$(ME): the above test(s)"\
502 " should use cleanup_ for background processes" 1>&2; exit
1; } ||
:
504 # Ensure that tests call the print_ver_ function for programs which are
505 # actually used in that test.
506 sc_prohibit_test_calls_print_ver_with_irrelevant_argument
:
507 @git grep
-w print_ver_
$(srcdir)/tests \
508 | sed
's#:print_ver_##' \
510 while read file name
; do \
511 for i in
$$name; do \
512 case
"$$i" in
install) i
=ginstall
;; esac
; \
513 grep
-w
"$$i" $$file|grep
-vw print_ver_|grep
-q . \
515 echo
"*** Test: $$file, offending: $$i." 1>&2; };\
518 test $$fail = 0 || exit
1; \
519 } ||
{ echo
"$(ME): the above test(s) call print_ver_ for" \
520 "program(s) they don't use" 1>&2; exit
1; }
522 # Exempt the contents of any usage function from the following.
523 _continued_string_col_1
= \
524 s
/^usage .
*?
\n}//ms
;/\\\n\w
/ and
print ("$$ARGV\n"),$$e=1;END
{$$e||
=0;exit
$$e}
525 # Ding any source file that has a continued string with an alphabetic in the
526 # first column of the following line. We prohibit them because they usually
527 # trigger false positives in tools that try to map an arbitrary line number
528 # to the enclosing function name. Of course, very many strings do precisely
529 # this, *when they are part of the usage function*. That is why we exempt
530 # the contents of any function named "usage".
531 sc_prohibit_continued_string_alpha_in_column_1
:
532 @perl
-0777 -ne
'$(_continued_string_col_1)' \
533 $$($(VC_LIST_EXCEPT
) | grep
'\.[ch]$$') \
534 ||
{ echo
'$(ME): continued string with word in first column' \
536 # Use this to list offending lines:
537 # git ls-files |grep '\.[ch]$' | xargs \
538 # perl -n -0777 -e 's/^usage.*?\n}//ms;/\\\n\w/ and print "$ARGV\n"' \
539 # | xargs grep -A1 '\\$'|grep '\.[ch][:-][_a-zA-Z]'
542 ###########################################################
543 _p0
= \
([^
"'/]\|"\
([^
\"]\|
[\
].\
)*"\|'\([^\']\|[\].\)*'
544 _pre = $(_p0)\|[/][^"'/*]\|[/]"\([^\"]\|[\].\)*"\|[/]'\
([^
\']\|
[\
].\
)*'\)*
545 _pre_anchored = ^\($(_pre)\)
546 _comment_and_close = [^*]\|[*][^/*]\)*[*][*]*/
547 # help font-lock mode: '
549 # A sed expression that removes ANSI C and ISO C99 comments.
550 # Derived from the one in GNU gettext's 'moopp' preprocessor.
551 _sed_remove_comments
= \
555 s
,$(_pre_anchored
)//.
*,\
1,; \
557 s
,$(_pre_anchored
)/[*]\
($(_comment_and_close
),\
1 ,; \
560 s
,$(_pre_anchored
)/[*].
*,\
1 ,; \
564 s
,^\
($(_comment_and_close
),,; \
572 # Quote all single quotes.
573 _sed_rm_comments_q
= $(subst ','\'',$(_sed_remove_comments))
574 # help font-lock mode: '
576 _space_before_paren_exempt
=?
\\n
\\$$
577 _space_before_paren_exempt
= \
578 (^
*\
#|\\n\\$$|%s\(to %s|(date|group|character)\(s\))
579 # Ensure that there is a space before each open parenthesis in C code.
580 sc_space_before_open_paren
:
581 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
583 for c in
$$($(VC_LIST_EXCEPT
) | grep
'\.[ch]$$'); do \
584 sed
'$(_sed_rm_comments_q)' $$c 2>/dev
/null \
585 | grep
-i
'[[:alnum:]](' \
586 | grep
-vE
'$(_space_before_paren_exempt)' \
587 | grep .
&& { fail
=1; echo
"*** $$c"; }; \
590 { echo
'$(ME): the above files lack a space-before-open-paren' \
591 1>&2; exit
1; } ||
:; \
595 # Similar to the gnulib maint.mk rule for sc_prohibit_strcmp
596 # Use STREQ_LEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
598 @prohibit
='^[^#].*str''ncmp *\(' \
599 halt
='use STREQ_LEN or STRPREFIX instead of str''ncmp' \
602 # Enforce recommended preprocessor indentation style.
603 sc_preprocessor_indentation
:
604 @if cppi
--version
>/dev
/null
2>&1; then \
605 $(VC_LIST_EXCEPT
) | grep
'\.[ch]$$' | xargs cppi
-a
-c \
606 ||
{ echo
'$(ME): incorrect preprocessor indentation' 1>&2; \
609 echo
'$(ME): skipping test $@: cppi not installed' 1>&2; \
612 # THANKS.in is a list of name/email pairs for people who are mentioned in
613 # commit logs (and generated ChangeLog), but who are not also listed as an
614 # author of a commit. Name/email pairs of commit authors are automatically
615 # extracted from the repository. As a very minor factorization, when
616 # someone who was initially listed only in THANKS.in later authors a commit,
617 # this rule detects that their pair may now be removed from THANKS.in.
618 sc_THANKS_in_duplicates
:
619 @
{ git log
--pretty
=format
:%aN |
sort -u
; \
620 cut
-b-36
$(srcdir)/THANKS.in \
621 | sed
'/^$$/,/^$$/!d;/^$$/d;s/ *$$//'; } \
622 |
sort | uniq
-d | grep . \
623 && { echo
'$(ME): remove the above names from THANKS.in' \
626 # Ensure the contributor list stays sorted. Use our sort as other
627 # implementations may result in a different order.
628 sc_THANKS_in_sorted
: src
/sort
629 @sed
'/^$$/,/^$$/!d;/^$$/d' $(srcdir)/THANKS.in
> $@
.1; \
630 LC_ALL
=en_US.UTF-8 src
/sort -f
-k1
,1 $@
.1 > $@
.2
631 @diff
-u
$@
.1 $@
.2; diff
=$$?
; \
634 ||
{ echo
'$(ME): THANKS.in is unsorted' 1>&2; exit
1; }
636 # Look for developer diagnostics that are marked for translation.
637 # This won't find any for which devmsg's format string is on a separate line.
638 sc_marked_devdiagnostics
:
639 @prohibit
='\<devmsg *\(.*_\(' \
640 halt
='found marked developer diagnostic(s)' \
643 # Ensure we keep hex constants as 4 or 8 bytes for consistency
644 # and so that make src/fs-magic-compare works consistently
646 @sed
-n
's|.*/\* \(0x[0-9A-Fa-f]\{1,\}\) .*\*/|\1|p' \
647 $(srcdir)/src
/stat.c | grep
-Ev
'^0x([0-9A-F]{4}){1,2}$$' \
648 && { echo
'$(ME): Constants in src/stat.c should be 4 or 8' \
649 'upper-case chars' 1>&2; exit
1; } ||
:
651 # Ensure gnulib generated files are ignored
652 # TODO: Perhaps augment gnulib-tool to do this in lib/.gitignore?
653 sc_gitignore_missing
:
654 @
{ sed
-n
'/^\/lib\/.*\.h$$/{p;p}' .gitignore
; \
655 find lib
-name
'*.in*' ! -name
'*~' ! -name
'sys_*' | \
656 sed
's|^|/|; s|_\(.*in\.h\)|/\1|; s/\.in//'; } | \
657 sort | uniq
-u | grep .
&& { echo
'$(ME): Add above' \
658 'entries to .gitignore' >&2; exit
1; } ||
:
660 # Flag redundant entreis in .gitignore
661 sc_gitignore_redundant
:
662 @
{ grep ^
/lib .gitignore
; sed
's|^|/lib|' lib
/.gitignore
; } | \
663 sort | uniq
-d | grep .
&& { echo
'$(ME): Remove above' \
664 'entries from .gitignore' >&2; exit
1; } ||
:
666 # Override the default Cc: used in generating an announcement.
667 announcement_Cc_
= $(translation_project_
), \
668 coreutils@gnu.org
, coreutils-announce@gnu.org
670 -include $(srcdir)/dist-check.mk
672 update-copyright-env
= \
673 UPDATE_COPYRIGHT_FORCE
=1 \
674 UPDATE_COPYRIGHT_USE_INTERVALS
=2 \
675 UPDATE_COPYRIGHT_MAX_LINE_LENGTH
=79
677 # List syntax-check exemptions.
678 exclude_file_name_regexp--sc_space_tab
= \
679 ^
(tests
/pr
/|tests
/misc
/nl\.sh
$$|gl
/.
*\.diff
$$|man
/help2man
$$)
680 exclude_file_name_regexp--sc_bindtextdomain
= \
681 ^
(gl
/.
*|lib
/euidaccess-stat|src
/make-prime-list
)\.c
$$
682 exclude_file_name_regexp--sc_trailing_blank
= ^
(tests
/pr
/|man
/help2man
)
683 exclude_file_name_regexp--sc_system_h_headers
= \
684 ^src
/((system|copy
)\.h|make-prime-list\.c
)$$
686 _src
= (false|lbracket|ls-
(dir|ls|vdir
)|tac-pipe|uname-
(arch|uname
))
687 exclude_file_name_regexp--sc_require_config_h_first
= \
688 (^lib
/buffer-lcm\.c|gl
/lib
/xdecto.max\.c|src
/$(_src
)\.c
)$$
689 exclude_file_name_regexp--sc_require_config_h
= \
690 $(exclude_file_name_regexp--sc_require_config_h_first
)
692 exclude_file_name_regexp--sc_po_check
= ^
(gl
/|man
/help2man
)
693 exclude_file_name_regexp--sc_prohibit_always-defined_macros
= \
694 ^src
/(seq|remove
)\.c
$$
695 exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF
= ^tests
/pr
/
696 exclude_file_name_regexp--sc_program_name
= \
697 ^
(gl
/.
*|lib
/euidaccess-stat|src
/make-prime-list
)\.c
$$
698 exclude_file_name_regexp--sc_file_system
= \
699 NEWS|^
(init\.cfg|src
/df\.c|tests
/df
/df-P\.sh|tests
/df
/df-output\.sh
)$$
700 exclude_file_name_regexp--sc_prohibit_always_true_header_tests
= \
702 exclude_file_name_regexp--sc_prohibit_fail_0
= \
703 (^.
*/git-hooks
/commit-msg|^tests
/init\.sh|Makefile\.am|\.mk|.
*\.texi
)$$
704 exclude_file_name_regexp--sc_prohibit_atoi_atof
= ^lib
/euidaccess-stat\.c
$$
706 # longlong.h is maintained elsewhere.
707 _ll
= ^src
/longlong\.h
$$
708 exclude_file_name_regexp--sc_useless_cpp_parens
= $(_ll
)
709 exclude_file_name_regexp--sc_space_before_open_paren
= $(_ll
)
711 tbi_1
= ^tests
/pr
/|
(^gl
/lib
/reg.
*\.c\.diff|\.mk|^man
/help2man
)$$
712 tbi_2
= ^scripts
/git-hooks
/(pre-commit|pre-applypatch|applypatch-msg
)$$
713 tbi_3
= (GNU
)?
[Mm
]akefile
(\.am
)?
$$|
$(_ll
)
714 exclude_file_name_regexp--sc_prohibit_tab_based_indentation
= \
715 $(tbi_1
)|
$(tbi_2
)|
$(tbi_3
)
717 exclude_file_name_regexp--sc_preprocessor_indentation
= \
718 ^
(gl
/lib
/rand-isaac\.
[ch
]|gl
/tests
/test-rand-isaac\.c
)$$|
$(_ll
)
719 exclude_file_name_regexp--sc_prohibit_stat_st_blocks
= \
720 ^
(src
/system\.h|tests
/du
/2g\.sh
)$$
722 exclude_file_name_regexp--sc_prohibit_continued_string_alpha_in_column_1
= \
723 ^src
/(system\.h|od\.c|printf\.c|getlimits\.c
)$$
725 exclude_file_name_regexp--sc_prohibit_test_backticks
= \
726 ^tests
/(local\.mk|
(init|misc
/stdbuf|factor
/create-test
)\.sh
)$$
728 # Exempt test.c, since it's nominally shared, and relatively static.
729 exclude_file_name_regexp--sc_prohibit_operator_at_end_of_line
= \
730 ^src
/(ptx|
test|head
)\.c
$$
732 exclude_file_name_regexp--sc_error_message_uppercase
= ^src
/factor\.c
$$
733 exclude_file_name_regexp--sc_prohibit_atoi_atof
= ^src
/make-prime-list\.c
$$
735 # Exception here as we don't want __attribute elided on non GCC
736 exclude_file_name_regexp--sc_prohibit-gl-attributes
= ^src
/libstdbuf\.c
$$
738 exclude_file_name_regexp--sc_prohibit_uppercase_id_est
= \.diff
$$
739 exclude_file_name_regexp--sc_ensure_dblspace_after_dot_before_id_est
= \.diff
$$
740 exclude_file_name_regexp--sc_ensure_comma_after_id_est
= \.diff|
$(_ll
)$$
741 exclude_file_name_regexp--sc_long_lines
= \.diff
$$|
$(_ll
)
743 # Augment AM_CFLAGS to include our per-directory options:
744 AM_CFLAGS
+= $($(@D
)_CFLAGS
)
746 src_CFLAGS
= $(WARN_CFLAGS
)
747 lib_CFLAGS
= $(GNULIB_WARN_CFLAGS
)
748 gnulib-tests_CFLAGS
= $(GNULIB_TEST_WARN_CFLAGS
)
750 # Configuration to make the tight-scope syntax-check rule work with
751 # non-recursive make.
752 export _gl_TS_headers
= $(srcdir)/cfg.mk
754 _gl_TS_obj_files
= src
/*.
$(OBJEXT
)
755 _gl_TS_other_headers
= $(srcdir)/src
/*.h src
/*.h
757 # Tell the tight_scope rule about an exceptional "extern" variable.
758 # Normally, the rule would detect its declaration, but that uses a
759 # different name, __clz_tab.
760 _gl_TS_unmarked_extern_vars
= factor_clz_tab